from flask import Flask, render_template, request, redirect, url_for, flash, session
from flask_bootstrap import Bootstrap
import pandas as pd
import os
import plotly.express as px

app = Flask(__name__)
app.secret_key = 'supersecretkey'
Bootstrap(app)

# Predefined credentials
USERNAME = 'tolerancia'
PASSWORD = '1234'

@app.route('/')
def index():
    return render_template('index.html')

@app.route('/submit', methods=['POST'])
def submit():
    if request.method == 'POST':
        data = {
            'Rol': request.form['rol'],
            'Sexo': request.form['sexo'],
            'Facultad': request.form['facultad'],
            'Pregunta1': request.form['pregunta1'],
            'Pregunta2': request.form['pregunta2'],
            'Pregunta3': request.form['pregunta3'],
            'Pregunta4': request.form['pregunta4'],
            'Pregunta5': request.form['pregunta5'],
            'Pregunta6': request.form['pregunta6'],
            'Pregunta7': request.form['pregunta7'],
            'Pregunta8': request.form['pregunta8'],
            'Pregunta9': request.form['pregunta9'],
            'Pregunta10': request.form['pregunta10'],
            'Pregunta11': request.form['pregunta11'],
            'Pregunta12': request.form['pregunta12'],
            'Pregunta13': request.form['pregunta13'],
            'Pregunta14': request.form['pregunta14'],
            'Pregunta15': request.form['pregunta15'],
            'Pregunta16': request.form['pregunta16'],
            'Pregunta17': request.form['pregunta17'],
            'Pregunta18': request.form['pregunta18'],
            'Pregunta19': request.form['pregunta19'],
            'Pregunta20': request.form['pregunta20'],
            'Pregunta21': request.form['pregunta21'],
            'Pregunta22': request.form['pregunta22'],
            'Pregunta23': request.form['pregunta23'],
            'Pregunta24': request.form['pregunta24'],
            'Pregunta25': request.form['pregunta25'],
            'Pregunta26': request.form['pregunta26'],
            'Pregunta27': request.form['pregunta27'],
            'Pregunta28': request.form['pregunta28'],
            'Pregunta29': request.form['pregunta29'],
            'Pregunta30': request.form['pregunta30'],
            'Pregunta31': request.form['pregunta31'],
            'Pregunta32': request.form['pregunta32'],
            'Pregunta33': request.form['pregunta33'],
            'Pregunta34': request.form['pregunta34'],
            'Pregunta35': request.form['pregunta35'],
            'Pregunta36': request.form['pregunta36'],
            'Pregunta37': request.form['pregunta37'],
            'Pregunta38': request.form['pregunta38'],
            'Pregunta39': request.form['pregunta39'],
            'Pregunta40': request.form['pregunta40'],
            'Pregunta41': request.form['pregunta41'],
            'Pregunta42': request.form['pregunta42'],
            'Pregunta43': request.form['pregunta43'],
            'Pregunta44': request.form['pregunta44'],
            'Pregunta45': request.form['pregunta45'],
            'Pregunta46': request.form['pregunta46'],
            'Pregunta47': request.form['pregunta47'],
            'Pregunta48': request.form['pregunta48'],
            'Pregunta49': request.form['pregunta49'],
            'Pregunta50': request.form['pregunta50'],
            'Pregunta51': request.form['pregunta51'],
            'Pregunta52': request.form['pregunta52'],
            'Pregunta53': request.form['pregunta53'],
        }

        df = pd.DataFrame([data])

        # Verificar si el archivo existe
        file_exists = os.path.isfile('data.xlsx')
        
        if file_exists:
            # Cargar datos existentes y agregar los nuevos
            existing_df = pd.read_excel('data.xlsx')
            df = pd.concat([existing_df, df], ignore_index=True)

        # Guardar los datos actualizados
        df.to_excel('data.xlsx', index=False)
        
        flash('Información registrada exitosamente!', 'success')
        
        # Redirigir a la página de inicio
        return redirect(url_for('index'))

    # En caso de que no sea un método POST, redirigir a la página de inicio
    return redirect(url_for('index'))


@app.route('/login', methods=['GET', 'POST'])
def login():
    if request.method == 'POST':
        username = request.form['username']
        password = request.form['password']
        if username == USERNAME and password == PASSWORD:
            session['logged_in'] = True
            return redirect(url_for('table'))
        else:
            flash('Credenciales incorrectas. Intenta nuevamente.')
    return render_template('login.html')

@app.route('/logout')
def logout():
    session['logged_in'] = False
    return redirect(url_for('index'))

@app.route('/table')
def table():
    if not session.get('logged_in'):
        return redirect(url_for('login'))
    df = pd.read_excel('data.xlsx')
    return render_template('table.html', tables=[df.to_html(classes='data')], titles=df.columns.values)


@app.route('/charts')
def charts():
    if not session.get('logged_in'):
        return redirect(url_for('login'))
    
    df = pd.read_excel('data.xlsx')
    
    # Contar respuestas para cada pregunta
    conteo_respuestas = {
        'Rol': df['Rol'].value_counts().reset_index(),
        'Sexo': df['Sexo'].value_counts().reset_index(),
        'Facultad': df['Facultad'].value_counts().reset_index(),
        'Pregunta1': df['Pregunta1'].value_counts().reset_index(),
        'Pregunta2': df['Pregunta2'].value_counts().reset_index(),
        'Pregunta3': df['Pregunta3'].value_counts().reset_index(),
        'Pregunta4': df['Pregunta4'].value_counts().reset_index(),
        'Pregunta5': df['Pregunta5'].value_counts().reset_index(),
        'Pregunta6': df['Pregunta6'].value_counts().reset_index(),
        'Pregunta7': df['Pregunta7'].value_counts().reset_index(),
        'Pregunta8': df['Pregunta8'].value_counts().reset_index(),
        'Pregunta9': df['Pregunta9'].value_counts().reset_index(),
        'Pregunta10': df['Pregunta10'].value_counts().reset_index(),
        'Pregunta11': df['Pregunta11'].value_counts().reset_index(),
        'Pregunta12': df['Pregunta12'].value_counts().reset_index(),
        'Pregunta13': df['Pregunta13'].value_counts().reset_index(),
        'Pregunta14': df['Pregunta14'].value_counts().reset_index(),
        'Pregunta15': df['Pregunta15'].value_counts().reset_index(),
        'Pregunta16': df['Pregunta16'].value_counts().reset_index(),
        'Pregunta17': df['Pregunta17'].value_counts().reset_index(),
        'Pregunta18': df['Pregunta18'].value_counts().reset_index(),
        'Pregunta19': df['Pregunta19'].value_counts().reset_index(),
        'Pregunta20': df['Pregunta20'].value_counts().reset_index(),
        'Pregunta21': df['Pregunta21'].value_counts().reset_index(),
        'Pregunta22': df['Pregunta22'].value_counts().reset_index(),
        'Pregunta23': df['Pregunta23'].value_counts().reset_index(),
        'Pregunta24': df['Pregunta24'].value_counts().reset_index(),
        'Pregunta25': df['Pregunta25'].value_counts().reset_index(),
        'Pregunta26': df['Pregunta26'].value_counts().reset_index(),
        'Pregunta27': df['Pregunta27'].value_counts().reset_index(),
        'Pregunta28': df['Pregunta28'].value_counts().reset_index(),
        'Pregunta29': df['Pregunta29'].value_counts().reset_index(),
        'Pregunta30': df['Pregunta30'].value_counts().reset_index(),
        'Pregunta31': df['Pregunta31'].value_counts().reset_index(),
        'Pregunta32': df['Pregunta32'].value_counts().reset_index(),
        'Pregunta33': df['Pregunta33'].value_counts().reset_index(),
        'Pregunta34': df['Pregunta34'].value_counts().reset_index(),
        'Pregunta35': df['Pregunta35'].value_counts().reset_index(),
        'Pregunta36': df['Pregunta36'].value_counts().reset_index(),
        'Pregunta37': df['Pregunta37'].value_counts().reset_index(),
        'Pregunta38': df['Pregunta38'].value_counts().reset_index(),
        'Pregunta39': df['Pregunta39'].value_counts().reset_index(),
        'Pregunta40': df['Pregunta40'].value_counts().reset_index(),
        'Pregunta41': df['Pregunta41'].value_counts().reset_index(),
        'Pregunta42': df['Pregunta42'].value_counts().reset_index(),
        'Pregunta43': df['Pregunta43'].value_counts().reset_index(),
        'Pregunta44': df['Pregunta44'].value_counts().reset_index(),
        'Pregunta45': df['Pregunta45'].value_counts().reset_index(),
        'Pregunta46': df['Pregunta46'].value_counts().reset_index(),
        'Pregunta47': df['Pregunta47'].value_counts().reset_index(),
        'Pregunta48': df['Pregunta48'].value_counts().reset_index(),
        'Pregunta49': df['Pregunta49'].value_counts().reset_index(),
        'Pregunta50': df['Pregunta50'].value_counts().reset_index(),
        'Pregunta51': df['Pregunta51'].value_counts().reset_index(),
        'Pregunta52': df['Pregunta52'].value_counts().reset_index(),
        'Pregunta53': df['Pregunta53'].value_counts().reset_index(),
    }

    
    # Renombrar las columnas para los gráficos
    conteo_respuestas['Rol'].columns = ['Respuesta', 'Conteo']
    conteo_respuestas['Sexo'].columns = ['Respuesta', 'Conteo']
    conteo_respuestas['Facultad'].columns = ['Respuesta', 'Conteo']

    # Crear gráfico de pie
    fig1 = px.pie(conteo_respuestas['Rol'], 
                   names='Respuesta', 
                   values='Conteo', 
                   title='Conteo de Respuestas - Rol',
                   color='Respuesta',
                   color_discrete_sequence=px.colors.qualitative.Set3)

    # Actualizar el diseño del gráfico (opcional)
    fig1.update_traces(textinfo='percent+label')  # Muestra el porcentaje y la etiqueta en el gráfico
    fig1.update_layout(
        title_font_size=24,  # Tamaño de la fuente del título
        legend_title_text='Tipo de Respuesta'  # Título de la leyenda
    )

    # Crear gráficos de barras solo para las tres primeras preguntas
    fig2 = px.bar(conteo_respuestas['Sexo'], x='Respuesta', y='Conteo', title='Conteo de Respuestas - Sexo')
    fig3 = px.bar(conteo_respuestas['Facultad'], x='Respuesta', y='Conteo', title='Conteo de Respuestas - Facultad')

    # Convertir los gráficos a HTML
    graph1 = fig1.to_html(full_html=False)
    graph2 = fig2.to_html(full_html=False)
    graph3 = fig3.to_html(full_html=False)

    # Convertir los conteos a HTML
    tablas_html = {}
    for pregunta, conteo in conteo_respuestas.items():
        conteo.columns = ['Respuesta', 'Conteo']
        tablas_html[pregunta] = conteo.to_html(classes='data', index=False)

    return render_template('charts.html', graph1=graph1, graph2=graph2, graph3=graph3,
                           tablas=tablas_html)


if __name__ == '__main__':
    app.run(debug=True)

